package org.gemoc.executionframework.engine.core;

import org.eclipse.emf.transaction.RecordingCommand;
import org.gemoc.executionframework.engine.core.AbstractSequentialExecutionEngine;

@SuppressWarnings("all")
public abstract class AbstractCommandBasedSequentialExecutionEngine extends AbstractSequentialExecutionEngine {
  /**
   * Must be called in a callback from the executed code from the operational
   * semantics.
   * 
   * @param caller
   * @param operationName
   * @param operation
   */
  protected void executeOperation(final Object caller, final String className, final String operationName, final Runnable operation) {
    final RecordingCommand rc = new RecordingCommand(this.editingDomain) {
      @Override
      public void doExecute() {
        operation.run();
      }
    };
    try {
      this.beforeExecutionStep(caller, className, operationName, rc);
      rc.execute();
      this.afterExecutionStep();
    } finally {
      rc.dispose();
    }
  }
}
